/*!
* image3D - 🍊 使用webGL绘制三维图片。Drawing three-dimensional images using webGL.
* git+https://github.com/yelloxing/image3D.git
*
* author 心叶
*
* version 2.0.8
*
* build Thu Apr 11 2019
*
* Copyright yelloxing
* Released under the MIT license
*
* Date:Sun Feb 09 2020 03:04:54 GMT+0800 (GMT+08:00)
*/

"use strict";var _typeof=typeof Symbol==="function"&&typeof Symbol.iterator==="symbol"?function(t){return typeof t}:function(t){return t&&typeof Symbol==="function"&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t};(function(){"use strict";var u=function t(r,n,e){var i=r.createShader(n);if(i==null)throw new Error("Unable to create shader!");r.shaderSource(i,e);r.compileShader(i);if(!r.getShaderParameter(i,r.COMPILE_STATUS))throw new Error("Failed to compile shader:"+r.getShaderInfoLog(i));return i};var o=function t(r,n,e){var i=u(r,r.VERTEX_SHADER,n),o=u(r,r.FRAGMENT_SHADER,e);var a=r.createProgram();r.attachShader(a,i);r.attachShader(a,o);r.linkProgram(a);if(!r.getProgramParameter(a,r.LINK_STATUS))throw new Error("Failed to link program: "+r.getProgramInfoLog(a));r.useProgram(a);return a};var a=function t(r,n){var e=r.createBuffer(),i=n?r.ELEMENT_ARRAY_BUFFER:r.ARRAY_BUFFER;r.bindBuffer(i,e);return e};var m=function t(r,n,e,i){var o=i?r.ELEMENT_ARRAY_BUFFER:r.ARRAY_BUFFER;r.bufferData(o,n,e)};var v=function t(r,n,e,i,o,a,u){r.vertexAttribPointer(n,e,i,u||false,o||0,a||0);r.enableVertexAttribArray(n)};var c=function t(r,n,e,i){var o=r.createTexture();if(i=="2d"){e=e||0;r.activeTexture(r["TEXTURE"+e])}r.bindTexture(n,o);return o};var l=function t(r,n,e,i,o,a){i={rgb:r.RGB,rgba:r.RGBA,alpha:r.ALPHA}[i]||r.RGBA;r.texImage2D(n,e||0,i,i,{}[o]||r.UNSIGNED_BYTE,a)};var g=function t(r,n,e,i,o,a,u,f,c){i={rgb:r.RGB,rgba:r.RGBA,alpha:r.ALPHA}[i]||r.RGBA;e=e||0;o={}[o]||r.UNSIGNED_BYTE;var s=[r.TEXTURE_CUBE_MAP_POSITIVE_X,r.TEXTURE_CUBE_MAP_NEGATIVE_X,r.TEXTURE_CUBE_MAP_POSITIVE_Y,r.TEXTURE_CUBE_MAP_NEGATIVE_Y,r.TEXTURE_CUBE_MAP_POSITIVE_Z,r.TEXTURE_CUBE_MAP_NEGATIVE_Z],m=void 0,v=void 0;for(m=0;m<s.length;m++){v=s[m];r.texImage2D(v,e,i,u,f,0,i,o,null);r.bindTexture(n,c);r.texImage2D(v,e,i,i,o,a[m])}r.generateMipmap(n)};function f(u){return{setAttribute1f:function t(r,n){var e=u.getAttribLocation(u.program,r);u.vertexAttrib1f(e,n)},setAttribute2f:function t(r,n,e){var i=u.getAttribLocation(u.program,r);u.vertexAttrib2f(i,n,e)},setAttribute3f:function t(r,n,e,i){var o=u.getAttribLocation(u.program,r);u.vertexAttrib3f(o,n,e,i)},setAttribute4f:function t(r,n,e,i,o){var a=u.getAttribLocation(u.program,r);u.vertexAttrib4f(a,n,e,i,o)},setAttribute1i:function t(r,n){var e=u.getAttribLocation(u.program,r);u.vertexAttrib1i(e,n)},setAttribute2i:function t(r,n,e){var i=u.getAttribLocation(u.program,r);u.vertexAttrib2i(i,n,e)},setAttribute3i:function t(r,n,e,i){var o=u.getAttribLocation(u.program,r);u.vertexAttrib3i(o,n,e,i)},setAttribute4i:function t(r,n,e,i,o){var a=u.getAttribLocation(u.program,r);u.vertexAttrib4i(a,n,e,i,o)},setUniform1f:function t(r,n){var e=u.getUniformLocation(u.program,r);u.uniform1f(e,n)},setUniform2f:function t(r,n,e){var i=u.getUniformLocation(u.program,r);u.uniform2f(i,n,e)},setUniform3f:function t(r,n,e,i){var o=u.getUniformLocation(u.program,r);u.uniform3f(o,n,e,i)},setUniform4f:function t(r,n,e,i,o){var a=u.getUniformLocation(u.program,r);u.uniform4f(a,n,e,i,o)},setUniform1i:function t(r,n){var e=u.getUniformLocation(u.program,r);u.uniform1i(e,n)},setUniform2i:function t(r,n,e){var i=u.getUniformLocation(u.program,r);u.uniform2i(i,n,e)},setUniform3i:function t(r,n,e,i){var o=u.getUniformLocation(u.program,r);u.uniform3i(o,n,e,i)},setUniform4i:function t(r,n,e,i,o){var a=u.getUniformLocation(u.program,r);u.uniform4i(a,n,e,i,o)},setUniformMatrix2fv:function t(r,n){var e=u.getUniformLocation(u.program,r);u.uniformMatrix2fv(e,false,n)},setUniformMatrix3fv:function t(r,n){var e=u.getUniformLocation(u.program,r);u.uniformMatrix3fv(e,false,n)},setUniformMatrix4fv:function t(r,n){var e=u.getUniformLocation(u.program,r);u.uniformMatrix4fv(e,false,n)}}}function E(i){var o={byte:i.UNSIGNED_BYTE,short:i.UNSIGNED_SHORT};return{openDeep:function t(){i.enable(i.DEPTH_TEST);return this},points:function t(r,n,e){if(e){i.drawElements(i.POINTS,n,o[e],r)}else{i.drawArrays(i.POINTS,r,n)}return this},lines:function t(r,n,e){if(e){i.drawElements(i.LINES,n,o[e],r)}else{i.drawArrays(i.LINES,r,n)}return this},stripLines:function t(r,n,e){if(e){i.drawElements(i.LINE_STRIP,n,o[e],r)}else{i.drawArrays(i.LINE_STRIP,r,n)}return this},loopLines:function t(r,n,e){if(e){i.drawElements(i.LINE_LOOP,n,o[e],r)}else{i.drawArrays(i.LINE_LOOP,r,n)}return this},triangles:function t(r,n,e){if(e){i.drawElements(i.TRIANGLES,n,o[e],r)}else{i.drawArrays(i.TRIANGLES,r,n)}return this},stripTriangles:function t(r,n,e){if(e){i.drawElements(i.TRIANGLE_STRIP,n,o[e],r)}else{i.drawArrays(i.TRIANGLE_STRIP,r,n)}return this},fanTriangles:function t(r,n,e){if(e){i.drawElements(i.TRIANGLE_FAN,n,o[e],r)}else{i.drawArrays(i.TRIANGLE_FAN,r,n)}return this}}}var _=function t(r,n){var e=["webgl","experimental-webgl","webkit-3d","moz-webgl"],i=null,o=void 0;for(o=0;o<e.length;o++){try{i=r.getContext(e[o],n)}catch(t){}if(i)break}return i};function s(t,r){var s=_(t,r),e={painter:function t(){return E(s)},shader:function t(r,n){s.program=o(s,r,n);return e},buffer:function t(e){a(s,e);var f=void 0,c={write:function t(r,n){n=n||s.STATIC_DRAW;m(s,r,n,e);f=r;return c},use:function t(r,n,e,i,o,a){var u=f.BYTES_PER_ELEMENT;if(typeof r=="string")r=s.getAttribLocation(s.program,r);e=e||0;i=i||0;o=o||s.FLOAT;v(s,r,n,o,e*u,i*u,a);return c}};return c},texture:function u(t,r){var f={"2d":s.TEXTURE_2D,cube:s.TEXTURE_CUBE_MAP}[t];var u=c(s,f,r,t);s.texParameteri(f,s.TEXTURE_MIN_FILTER,s.NEAREST);s.texParameteri(f,s.TEXTURE_WRAP_S,s.CLAMP_TO_EDGE);s.texParameteri(f,s.TEXTURE_WRAP_T,s.CLAMP_TO_EDGE);var o={useImage:function t(r,n,e,i){l(s,f,n,e,i,r);return o},useCube:function t(r,n,e,i,o,a){g(s,f,i,o,a,r,n,e,u)}};return o}};var n=f(s);for(var i in n){e[i]=n[i]}return e}function p(t,r){for(var n in r){try{t[n]=r[n]}catch(t){throw new Error("Illegal property key : "+n)}}return t}function A(n,t){return function(r){return new function t(){var i=this;var o=n.buffer(r);this.write=function(t){o.write(t);return i};if(!r){this.use=function(t,r,n,e){o.use(t,r,n,e);return i}}}}}function T(t,r,n,e){e=e||0;var i=Math.sqrt(r*r+n*n+e*e);return[1,0,0,0,0,1,0,0,0,0,1,0,r*t/i,n*t/i,e*t/i,1]}function b(t){var r=Math.sin(t),n=Math.cos(t);return[n,r,0,0,-r,n,0,0,0,0,1,0,0,0,0,1]}function d(t,r,n,e,i,o){e=e||0;i=i||0;o=o||0;return[t,0,0,0,0,r,0,0,0,0,n,0,e-e*t,i-i*r,o-o*n,1]}function h(t,r,n,e,i,o){if(typeof t==="number"&&typeof r==="number"){if(typeof n!=="number"){n=0;e=t;i=r;o=1}else if(typeof e!=="number"||typeof i!=="number"||typeof o!=="number"){e=t;i=r;o=n;t=0;r=0;n=0}if(t==e&&r==i&&n==o)throw new Error("It's not a legitimate ray!");var a=Math.sqrt((e-t)*(e-t)+(i-r)*(i-r)),u=a!=0?(i-r)/a:1,f=a!=0?(e-t)/a:0,c=(e-t)*f+(i-r)*u,s=o-n,m=Math.sqrt(c*c+s*s),v=m!=0?s/m:1,l=m!=0?c/m:0;return[[u,v*f,f*l,0,-f,u*v,u*l,0,0,-l,v,0,r*f-t*u,n*l-t*f*v-r*u*v,-t*f*l-r*u*l-n*v,1],[u,-f,0,0,v*f,v*u,-l,0,f*l,u*l,v,0,t,r,n,1]]}else{throw new Error("a1 and b1 is required!")}}var L=function t(r,n){var e=[];for(var i=0;i<4;i++){for(var o=0;o<n.length/4;o++){e[o*4+i]=r[i]*n[o*4]+r[i+4]*n[o*4+1]+r[i+8]*n[o*4+2]+r[i+12]*n[o*4+3]}}return e};function n(t){var c=t||[1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1];var s={move:function t(r,n,e,i){c=L(T(r,n,e,i),c);return s},rotate:function t(r,n,e,i,o,a,u){var f=h(n,e,i,o,a,u);c=L(L(L(f[1],b(r)),f[0]),c);return s},scale:function t(r,n,e,i,o,a){c=L(d(r,n,e,i,o,a),c);return s},multiply:function t(r,n){c=n?L(c,r):L(r,c);return s},use:function t(r,n,e,i){e=e||0;i=i||1;var o=L(c,[r,n,e,i]);o[0]=+o[0].toFixed(7);o[1]=+o[1].toFixed(7);o[2]=+o[2].toFixed(7);o[3]=+o[3].toFixed(7);return o},value:function t(){return c}};return s}function y(t,r){return function(){return new function t(){var u=this;var f=n();this.rotateEye=function(t,r,n,e,i,o,a){f.rotate(-t,r,n,e,i,o,a);return u};this.moveEye=function(t,r,n,e){f.move(-t,r,n,e);return u};this.rotateBody=function(t,r,n,e,i,o,a){f.rotate(t,r,n,e,i,o,a);return u};this.moveBody=function(t,r,n,e){f.move(t,r,n,e);return u};this.scaleBody=function(t,r,n,e,i,o){f.scale(t,r,n,e,i,o);return u};this.value=function(){return f.value()}}}}function e(n,e){e.drawPoint=function(t,r){n.points(t,r);return e};e.drawLine=function(t,r){n.lines(t,r);return e};e.drawStripLine=function(t,r){n.stripLines(t,r);return e};e.drawLoopLine=function(t,r){n.loopLines(t,r);return e};e.drawTriangle=function(t,r){n.triangles(t,r);return e};e.drawStripTriangle=function(t,r){n.stripTriangles(t,r);return e};e.drawFanTriangle=function(t,r){n.fanTriangles(t,r);return e}}function i(e,i){i.elemPoint=function(t,r,n){n=n||"byte";e.points(t,r,n);return i};i.elemLine=function(t,r,n){n=n||"byte";e.lines(t,r,n);return i};i.elemStripLine=function(t,r,n){n=n||"byte";e.stripLines(t,r,n);return i};i.elemLoopLine=function(t,r,n){n=n||"byte";e.loopLines(t,r,n);return i};i.elemTriangle=function(t,r,n){n=n||"byte";e.triangles(t,r,n);return i};i.elemStripTriangle=function(t,r,n){n=n||"byte";e.stripTriangles(t,r,n);return i};i.elemFanTriangle=function(t,r,n){n=n||"byte";e.fanTriangles(t,r,n);return i}}function U(t,r){var n=t.painter();if(r.depth){n.openDeep()}return function(){return new function t(){e(n,this);i(n,this)}}}function w(i,t){return function(e){return new function t(){var r=this;var n=i.texture("2d",e);this.write=function(t){n.useImage(t);return r}}}}function R(r,t){return function(f,c){return new function t(){var a=this;var u=r.texture("cube");this.write=function(t,r,n,e,i,o){u.useCube([t,r,n,e,i,o],f,c);return a}}}}var r={vs:"\n    attribute vec4 a_position;\n    attribute vec4 a_color;\n    attribute float a_size;\n    varying vec4 v_color;\n    void main(){\n        gl_Position=a_position;\n        gl_PointSize=a_size;\n        v_color=a_color;\n    }\n    ",fs:"\n    precision mediump float;\n    varying vec4 v_color;\n    void main(){\n        gl_FragColor=v_color;\n    }\n    "};var I={vs:"\n    attribute vec4 a_position;\n    attribute vec4 a_color;\n    attribute float a_size;\n    varying vec4 v_color;\n    uniform mat4 u_matrix;\n    void main(){\n        gl_Position=u_matrix * a_position;\n        gl_PointSize=a_size;\n        v_color=a_color;\n    }\n    ",fs:"\n    precision mediump float;\n    varying vec4 v_color;\n    void main(){\n        gl_FragColor=v_color;\n    }\n    "};function S(t){return{type_default:r,type_camera:I}["type_"+t]}var t=function t(r,n){var e=p({depth:false},n||{});var o=s(r);var i=e["vertex-shader"],a=e["fragment-shader"];if(!i||!a){var u=S(e.shader||"default");i=u.vs;a=u.fs}o.shader(i,a);t.fn=t.prototype;t.fn.Buffer=A(o);t.fn.Camera=y();t.fn.Painter=U(o,e);t.fn.Texture2D=w(o);t.fn.TextureCube=R(o);t.fn.setAttributeFloat=function(t,r,n,e,i){o["setAttribute"+(arguments.length-1)+"f"](t,r,n,e,i);return this};t.fn.setAttributeInt=function(t,r,n,e,i){o["setAttribute"+(arguments.length-1)+"i"](t,r,n,e,i);return this};t.fn.setUniformFloat=function(t,r,n,e,i){o["setUniform"+(arguments.length-1)+"f"](t,r,n,e,i);return this};t.fn.setUniformInt=function(t,r,n,e,i){o["setUniform"+(arguments.length-1)+"i"](t,r,n,e,i);return this};t.fn.setUniformMatrix=function(t,r){var n={4:2,9:3,16:4}[r.length];o["setUniformMatrix"+n+"fv"](t,r);return this}};t.core=s;if((typeof module==="undefined"?"undefined":_typeof(module))==="object"&&_typeof(module.exports)==="object"){module.exports=t}else{var P=window.image3D;t.noConflict=function(){if(window.image3D===t){window.image3D=P}return t};window.image3D=t}})();